{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   bootmain.pp                                          }
{     縵Υᥤ롼Ȥεư                 }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: bootmain.pp,v 1.6 2002/08/10 03:05:14 rero2 Exp $ }
Program lmpuzzle02;

{$MODE Delphi}

Uses SDL, SDL_Types, SDL_Video, SDL_Audio, SDL_Timer,
     Grp_Screen, Debug, Input, Sound,
     GameMain;

Const
   { ----- ̥ }
   width = 480;
   height = 360;
   depth = 32;
   WindowName = 'Shippo no Puzzle - Tail Tale';
   { ----- ե졼졼Ȥ }
   FrameRate = 30;

Var
  i: Integer;
  { --- ᥤ롼롼ץե饰 }
  EndFlag: Boolean;
  { --- ५ }
  SystemTime: Uint32;
  BeforeTiming: Uint32;
  NowTiming: Uint32;
  WorkTime: Uint32;
  FrameCounter: Integer;
  { ----- ̴饹 }
  screen: TGameScreen;
  { ----- ॳƥ }
  gamebody: TGameMain;

{$undef DEBUG}

{ --------------------------------------------- }
{ --- ᥤ롼                        --- }
{ --------------------------------------------- }
Begin
  { ----- SDL  }
  i := SDL_Init(SDL_INIT_VIDEO or SDL_INIT_AUDIO or SDL_INIT_TIMER);
  if i <> 0 then
  begin
    { --- SDLʤä }
    WriteLn('SDL initialize error.');
    Exit;
  end;
  

  { --- λե饰 }
  EndFlag := False;

  { ----- ϡɥ }
  InputInit;
  SoundInit;
  Screen := TGameScreen.Create(width, height, depth);
  if Screen.Screen = nil then
  begin
    { --- ꡼󤬽ʤä }
    WriteLn('SDL Screen initialize error.');
    EndFlag := True;
  end;
  Screen.SetWMName(WindowName);
  SystemTime := SDL_GetTicks;
  BeforeTiming := SystemTime;
  Randomize;
  { ----- ǥХå롼 }
{$ifdef DEBUG}
  DebugInit(Screen, width, height, depth);  
{$endif}
  { -----  }
  gamebody := TGameMain.Create(Screen);
  if gamebody = nil then
  begin
    WriteLn('GameMain initialize error.');
    EndFlag := True;
  end;

  { ---------------------------------------- }
  { ----- ᥤ롼                     }
  { ---------------------------------------- }
  while EndFlag = FALSE do
  begin
    { --- Υ롼 }
    FrameCounter := FrameCounter + 1;
    InputPoll;
    { ------------------------------- }
    { ----- ᥤءġ }
    gamebody.poll(FrameCounter);

    { --- ե졼ཪλ꡼ }
    screen.DispScreen;
{$ifdef DEBUG}
    DebugPrint(IntToStr(FrameCounter));
    DebugPrint('Work Time : '+IntToStr(WorkTime)+'/'+IntToStr(1000 div FrameRate));
    DebugPrint('Key Input : '+IntToHex(InputJoyKey(0), 4));
    DebugDisp(screen);  
{$endif}
    screen.RefreshScreen;
    { --- ե졼ॿޡ }
    WorkTime := SDL_GetTicks - BeforeTiming;
    NowTiming := (1000 div FrameRate) - WorkTime;
    if NowTiming <= (1000 div FrameRate) then
      SDL_Delay(NowTiming);
    BeforeTiming := SDL_GetTicks;
    EndFlag := InputExit;
  end;

  { ---------------------------------------- }
  { ----- ᥤ롼פޤ               }

  
{$ifdef DEBUG}
  DebugFree;  
{$endif}
  { --- ꡼ }
  Screen.Free;
  { --- λSDL  }
  SoundFree;
  InputFree;
  SDL_Quit;
end.
